import { DeepReadonly } from "vue";
import { InvokerModName } from "./components/Invoker";

let _modPageConfig = {
    Invoker: {
        invokerKey: "MES_MOD_INVOKERS",
        /** Invoker中计算ModUrl的方法 */
        GetModUrl: undefined as ((modName: InvokerModName, invokerId: string, invokerKey: string) => string | Promise<string>) | undefined,
    }
}

export function ConfigureModPage(config: DeepPartial<typeof _modPageConfig>) {
    Object.assign(_modPageConfig, {
        ..._modPageConfig,
        ...config,
        Invoker: {
            ..._modPageConfig.Invoker,
            ...config?.Invoker
        }
    });
}

export const modPageConfig: DeepReadonly<typeof _modPageConfig> = _modPageConfig;

type DeepPartial<T> = T extends Function // 排除Function，因为Function也是object
  ? T
  : T extends object
  ? {
      [P in keyof T]?: DeepPartial<T[P]>;
    }
  : T;